//CONFIGURAZIONE
/* Attenzione! Se modifichi questi parametri, assicurati di sapere ciò
che stai facendo, altrimenti il programma potrebbe non partire più! */
	var nodeDim = 2;
	var nodeColor = "black";
    var labelFontSize = 16;
    var circuit0Color = "black";
    var circuit1Color = "red";
    var buttonsFillColor = ["white","red"];
    var displayFillColor = ["#B7B7B7","red"];
    var displayBackColor = "lightgrey";
    var displayStrokeColor = "darkgrey";
    var glowOnParameters = [10,false,0.5,0,0,"black"];
    var circuitStrokeWidth = [1,3];
    var vValue = ["0","1"];

//Oggetti del disegno instanziati globalmente in modo da poter
//essere visti anche al di fuori della funzione principale
    var paper,
    //Etichette degli ingressi
    i1, i2, i3, i4,
    // Porte NOT e relativi elementi grafici
    not1, not2, not3, not4, not_12, not_34, not_678, not_x4n9, not_1314,
    not1c, not2c, not3c, not4c, not_12c, not_34c, not_678c, not_x4n9c, not_1314c,
    // Porte NAND e relativi elementi grafici
    nand1, nand2, nand3, nand4, nand5, nand6, nand7,
    nand8, nand9, nand10, nand11, nand12, nand13, nand14,
    nand_12, nand_34, nand_678, nand_x4n9, nand_101112, nand_1314,
    nand1c, nand2c, nand3c, nand4c, nand5c, nand6c, nand7c,
    nand8c, nand9c, nand10c, nand11c, nand12c, nand13c, nand14c,
    nand_12c, nand_34c, nand_678c, nand_x4n9c, nand_101112c, nand_1314c,
    // Nodi
    node1, node2, node3, node4, node5, node6, node7, node8, node9, node10, 
    node11, node12, node13, node14, node15, node16, node17, node18, node19, node20, 
    node21, node22, node23, node24, node25, node26, node27, node28, node29, node30, 
    node31, node32, node33, node34, node35, node36, node37, node38,
    //Fili
    x1,x2,x3,x4,x1n,x2n,x3n,x4n,
    n1, n2, n3, n4, n6, n7, n8, n9, n10, n11, n12, n13, n14,
    n_12, n_34, n_678, n_x4n9, n_101112, n_1314,
    oa, ob, oc, od, oe, of, og,
    ua, ub, uc, ud, ue, uf, ug,
    p1, p2, p3, p4,
    lblp1, lblp2, lblp3, lblp4,
    lblInput, lblOutput,
    sa, sb, sc, sd, se, sf, sg,
    v1,v2,v3,v4,
    vx1,vx2,vx3,vx4,
    pSimula, lblSimula,
    cLetters, lblLetters, showLetters = false,
    lbla, lblb, lblc, lbld, lble, lblf, lblg,
    displayContainer;

var input = [0,0,0,0];

//Risultati parziali delle porte NAND
var pnand = [0,0,0,0,0,0,0,0,0,0,0,0,0,0];

function buttons(i, elem, v, vx){ // Aggiorna l'input e i pulsanti
            if (input[i]==0) input[i]=1;
            else input[i]=0;
            elem.attr({"fill":buttonsFillColor[input[i]]});
            v.attr({"text":vValue[input[i]]});
            //update();
}

function update(){ // Aggiorna il circuito e l'output
            vx1.attr({"text":vValue[input[0]]});
            vx2.attr({"text":vValue[input[1]]});
            vx3.attr({"text":vValue[input[2]]});
            vx4.attr({"text":vValue[input[3]]});
            if(input[0] == 1){
                x1.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                x1n.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                x1.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                x1n.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1] == 1){
                x2.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                x2n.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                x2.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                x2n.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[2] == 1){
                x3.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                x3n.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                x3.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                x3n.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[3] == 1){
                x4.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                x4n.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                x4.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                x4n.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[0]==0 && input[1]==0 && input[2] == 0 && input[3] == 1){
                pnand[0] = 0;
                n1.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                pnand[5] = 0;
                n6.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[0] = 1;
                n1.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                pnand[5] = 1;
                n6.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==1 && input[2]==0 && input[3]==0){
                pnand[1] = 0;
                n2.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                pnand[6] = 0;
                n7.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[1] = 1;
                n2.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                pnand[6] = 1;
                n7.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==1 && input[2]==0 && input[3]==1){
                pnand[2] = 0;
                n3.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[2] = 1;
                n3.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==1 && input[2]==1 && input[3]==0){
                pnand[3] = 0;
                n4.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[3] = 1;
                n4.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==0 && input[2]==1 && input[3]==0){
                pnand[4] = 0;
                oc.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                sc.attr({"fill":displayFillColor[0]});
            }
            else {
                pnand[4] = 1;
                oc.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                sc.attr({"fill":displayFillColor[1]});
            }
            if(input[1]==1 && input[2]==1 && input[3]==1){
                pnand[7] = 0;
                n8.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[7] = 1;
                n8.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==1 && input[2]==0){
                pnand[8] = 0;
                n9.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[8] = 1;
                n9.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==0 && input[2]==1){
                pnand[9] = 0;
                n10.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[9] = 1;
                n10.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[2]==1 && input[3]==1){
                pnand[10] = 0;
                n11.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[10] = 1;
                n11.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[0]==0 && input[1]==0 && input[3]==1){
                pnand[11] = 0;
                n12.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[11] = 1;
                n12.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[0]==0 && input[1]==0 && input[2]==0){
                pnand[12] = 0;
                n13.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[12] = 1;
                n13.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(input[1]==1 && input[2]==1 && input[3]==1){
                pnand[13] = 0;
                n14.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
            }
            else {
                pnand[13] = 1;
                n14.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
            }
            if(pnand[0]==1 && pnand[1]==1){
                n_12.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                oa.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                sa.attr({"fill":displayFillColor[1]});
            }
            else {
                n_12.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                oa.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                sa.attr({"fill":displayFillColor[0]});
            }
            if(pnand[2]==1 && pnand[3]==1){
                n_34.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                ob.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                sb.attr({"fill":displayFillColor[1]});
            }
            else {
                n_34.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                ob.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                sb.attr({"fill":displayFillColor[0]});
            }
            if(pnand[5]==1 && pnand[6]==1 && pnand[7]==1){
                n_678.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                od.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                sd.attr({"fill":displayFillColor[1]});
            }
            else {
                n_678.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                od.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                sd.attr({"fill":displayFillColor[0]});
            }
            if(input[3]==0 && pnand[8]==1){
                n_x4n9.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                oe.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                se.attr({"fill":displayFillColor[1]});
            }
            else {
                n_x4n9.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                oe.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                se.attr({"fill":displayFillColor[0]});
            }
            if(pnand[9]==1 && pnand[10]==1 && pnand[11]==1){
                n_101112.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                of.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                sf.attr({"fill":displayFillColor[1]});
            }
            else {
                n_101112.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                of.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                sf.attr({"fill":displayFillColor[0]});
            }
            if(pnand[12]==1 && pnand[13]==1){
                n_1314.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                og.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                sg.attr({"fill":displayFillColor[1]});
            }
            else {
                n_1314.attr({"stroke":circuit1Color,"stroke-width":circuitStrokeWidth[1]});
                og.attr({"stroke":circuit0Color,"stroke-width":circuitStrokeWidth[0]});
                sg.attr({"fill":displayFillColor[0]});
            }
        }

window.onload = function() { // Disegno vettoriale del circuito
	// Inizializzazione del canvas a nuovo oggetto Raphael (gestibile dal framework Raphael Js utilizzato per questo progetto) di dimensione 1000*500
    paper = new Raphael(document.getElementById('canvas_container'), 1000, 500);
    // Etichette degli ingressi
    i1 = paper.text(50, 45, "x1").attr({"font-size":labelFontSize});
    i2 = paper.text(50, 85, "x2").attr({"font-size":labelFontSize});
    i3 = paper.text(50, 125, "x3").attr({"font-size":labelFontSize});
    i4 = paper.text(50, 165, "x4").attr({"font-size":labelFontSize});
    // Porte NOT e relativi elementi grafici
    not1 = paper.path("M100 35L100 55L120 45L100 35");
    not1c= paper.circle(123, 45, 3);
    not2 = paper.path("M100 75L100 95L120 85L100 75");
    not2c= paper.circle(123, 85, 3);
    not3 = paper.path("M100 115L100 135L120 125L100 115");
    not3c= paper.circle(123, 125, 3);
    not4 = paper.path("M100 155L100 175L120 165L100 155");
    not4c= paper.circle(123, 165, 3);
    not_12 = paper.path("M392,56.25 V76.25 L412,66.25 L392,56.25");
    not_12c = paper.circle(415, 66.25, 3);
    not_34 = paper.path("M392,115 V135 L412,125 L392,115");
    not_34c = paper.circle(415, 125, 3);
    not_678 = paper.path("M392,220 V240 L412,230 L392,220");
    not_678c = paper.circle(415, 230, 3);
    not_x4n9 = paper.path("M392,275 V295 L412,285 L392,275");
    not_x4n9c = paper.circle(415, 285, 3);
    not_101112 = paper.path("M392,340 V360 L412,350 L392,340");
    not_101112c = paper.circle(415, 350, 3);
    not_1314 = paper.path("M392,415 V435 L412,425 L392,415");
    not_1314c = paper.circle(415, 425, 3);
    // porte NAND e relativi elementi grafici
    nand1 = paper.path("M300 42.5L300 62.5L310 62.5A5 5 0 1 0 310 42.5L300 42.5");
    nand1c = paper.circle(323, 52.5, 3);
    nand2 = paper.path("M300 70L300 90L310 90A5 5 0 1 0 310 70L300 70");
    nand2c = paper.circle(323, 80, 3);
    nand3 = paper.path("M300 100L300 120L310 120A5 5 0 1 0 310 100L300 100");
    nand3c = paper.circle(323, 110, 3);
    nand4 = paper.path("M300 130L300 150L310 150A5 5 0 1 0 310 130L300 130");
    nand4c = paper.circle(323, 140, 3);
    nand5 = paper.path("M300 160L300 180L310 180A5 5 0 1 0 310 160L300 160");
    nand5c = paper.circle(323, 170, 3);
    nand6 = paper.path("M300 192.5L300 212.5L310 212.5A5 5 0 1 0 310 192.5L300 192.5");
    nand6c = paper.circle(323, 202.5, 3);
    nand7 = paper.path("M300 220L300 240L310 240A5 5 0 1 0 310 220L300 220");
    nand7c = paper.circle(323, 230, 3);
    nand8 = paper.path("M300 250L300 270L310 270A5 5 0 1 0 310 250L300 250");
    nand8c = paper.circle(323, 260, 3);
    nand9 = paper.path("M300 280L300 300L310 300A5 5 0 1 0 310 280L300 280");
    nand9c = paper.circle(323, 290, 3);
    nand10 = paper.path("M300 310L300 330L310 330A5 5 0 1 0 310 310L300 310");
    nand10c = paper.circle(323, 320, 3);
    nand11 = paper.path("M300 340L300 360L310 360A5 5 0 1 0 310 340L300 340");
    nand11c = paper.circle(323, 350, 3);
    nand12 = paper.path("M300 370L300 390L310 390A5 5 0 1 0 310 370L300 370");
    nand12c = paper.circle(323, 380, 3);
    nand13 = paper.path("M300 400L300 420L310 420A5 5 0 1 0 310 400L300 400");
    nand13c = paper.circle(323, 410, 3);
    nand14 = paper.path("M300 430L300 450L310 450A5 5 0 1 0 310 430L300 430");
    nand14c = paper.circle(323, 440, 3);
    nand_12 = paper.path("M346 56.25L346 76.25L356 76.25A5 5 0 1 0 356 56.25L346 56.25");
    nand_12c = paper.circle(369, 66.25, 3);
    nand_34 = paper.path("M346 115L346 135L356 135A5 5 0 1 0 356 115L346 115");
    nand_34c = paper.circle(369, 125, 3);
    nand_678 = paper.path("M346 220L346 240L356 240A5 5 0 1 0 356 220L346 220");
    nand_678c = paper.circle(369, 230, 3);
    nand_x4n9 = paper.path("M346 275L346 295L356 295A5 5 0 1 0 356 275L346 275");
    nand_x4n9 = paper.circle(369, 285, 3);
    nand_101112 = paper.path("M346 340L346 360L356 360A5 5 0 1 0 356 340L346 340");
    nand_101112c = paper.circle(369, 350, 3);
    nand_1314 = paper.path("M346 415L346 435L356 435A5 5 0 1 0 356 415L346 415");
    nand_1314c = paper.circle(369, 425, 3);
    // Percorsi dei fili
    x1 = paper.path("M60 45L100 45");
    x1n = paper.path("M126 45L300 45M145 45L145 405L300 405M145 375L300 375M145 195L300 195");
    x2 = paper.path("M60 85L100 85M80 85L80 105L300 105M164 75L300 75M164 75L164 435M164 135L300 135M164 225L300 225M164 255L300 255M164 285L300 285M164 435L300 435");
    x2n = paper.path("M183,50 L300,50 M183,50 L183,410 L300,410 M126,85 L183,85 M183,175 L300,175 M183,200 L300,200 M183,315 L300,315 M183,380 L300,380");
    x3 = paper.path("M60,125 L100,125 M80,125 L80,140 L300,140 M202,170 L300,170 M202,260 L300,260 M202,325 L300,325 M202,345 L300,345 M202,440 L300,440 M202,140 L202,440");
    x3n = paper.path("M126,125 L221,125 M221,55 L221,415 L300,415 M221,55 L300,55 M221,80 L300,80 M221,205 L300,205 M221,230 L300,230 M221,295 L300,295 M221,110 L300,110");
    x4 = paper.path("M60,165 L100,165 M80,165 L80,185 L240,185 L240,60 L300,60 M240,115 L300,115 M240,210 L300,210 M240,265 L300,265 M240,355 L300,355 M240,385 L300,385 M240,185 L240,385 M240,445 H300 M240,445 V385");
    x4n = paper.path("M126,165 H259 V85 H300 M259,145 H300 M259,165 H300 M259,165 V275 H336 V280 H346 M259,235 H300");

    n1 = paper.path("M326,52.5 H336 V60 H346");
    n2 = paper.path("M326,80 H336 V72.5 H346");
    n3 = paper.path("M326,110 H336 V120 H346");
    n4 = paper.path("M326,140 H336 V130 H346");
        //n5 non è presente, il filo si chiama "oc" perché è già un output
    n6 = paper.path("M326,202.5 H336 V225 H346");
    n7 = paper.path("M326,230 H346");
    n8 = paper.path("M326,260 H336 V235 H346");
    n9 = paper.path("M326,290 H346");
    n10 = paper.path("M326,320 H336 V345 H346");
    n11 = paper.path("M326,350 H346");
    n12 = paper.path("M326,380 H336 V355 H346");
    n13 = paper.path("M326,410 H336 V420 H346");
    n14 = paper.path("M326,440 H336 V430 H346");

    n_12 = paper.path("M372,66.25 H392");
    n_34 = paper.path("M372,125 H392");
    n_678 = paper.path("M372,230 H392");
    n_x4n9 = paper.path("M372,285 H392");
    n_101112 = paper.path("M372,350 H392");
    n_1314 = paper.path("M372,425 H392");

    oa = paper.path("M418,66.25 H480");
    ob = paper.path("M418,125 H480");
    oc = paper.path("M326,170 H480");
    od = paper.path("M418,230 H480");
    oe = paper.path("M418,285 H480");
    of = paper.path("M418,350 H480");
    og = paper.path("M418,425 H480");

    // Nodi
    node1 = paper.circle(145, 45, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node2 = paper.circle(145, 195, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node3 = paper.circle(145, 375, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node4 = paper.circle(145, 405, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node5 = paper.circle(164, 105, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node6 = paper.circle(164, 135, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node7 = paper.circle(164, 225, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node8 = paper.circle(164, 255, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node9 = paper.circle(164, 285, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node10 = paper.circle(164, 435, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node11 = paper.circle(183, 85, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node12 = paper.circle(183, 175, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node13 = paper.circle(183, 200, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node14 = paper.circle(183, 315, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node15 = paper.circle(183, 380, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node16 = paper.circle(183, 410, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node17 = paper.circle(202, 140, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node18 = paper.circle(202, 170, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node19 = paper.circle(202, 260, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node20 = paper.circle(202, 325, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node21 = paper.circle(202, 345, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node22 = paper.circle(202, 440, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node23 = paper.circle(221, 80, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node24 = paper.circle(221, 125, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node25 = paper.circle(221, 205, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node26 = paper.circle(221, 230, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node27 = paper.circle(221, 295, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node28 = paper.circle(221, 110, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node29 = paper.circle(240, 185, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node30 = paper.circle(240, 60, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node31 = paper.circle(240, 115, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node32 = paper.circle(240, 210, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node33 = paper.circle(240, 265, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node34 = paper.circle(240, 355, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node35 = paper.circle(240, 385, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node36 = paper.circle(259, 145, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node37 = paper.circle(259, 165, nodeDim).attr({fill: nodeColor,stroke: nodeColor});
    node38 = paper.circle(259, 235, nodeDim).attr({fill: nodeColor,stroke: nodeColor});

    //Etichette delle uscite
    ua = paper.text(490,66.25,"a").attr({"font-size":labelFontSize});
    ub = paper.text(490,125,"b").attr({"font-size":labelFontSize});
    uc = paper.text(490,170,"c").attr({"font-size":labelFontSize});
    ud = paper.text(490,230,"d").attr({"font-size":labelFontSize});
    ue = paper.text(490,285,"e").attr({"font-size":labelFontSize});
    uf = paper.text(490,350,"f").attr({"font-size":labelFontSize});
    ug = paper.text(490,425,"g").attr({"font-size":labelFontSize});


    lblInput = paper.text(600, 66.25, "Input").attr({"font-size":16});
    lblp1 = paper.text(665, 42, "x1").attr({"font-size":16});
    lblp2 = paper.text(715, 42, "x2").attr({"font-size":16});
    lblp3 = paper.text(765, 42, "x3").attr({"font-size":16});
    lblp4 = paper.text(815, 42, "x4").attr({"font-size":16});
    p1 = paper.rect(650, 51.25, 30, 30).attr({"fill":buttonsFillColor[0]}).click(function(){
            buttons(0,p1,v1,vx1);
        });
    p2 = paper.rect(700, 51.25, 30, 30).attr({"fill":buttonsFillColor[0]}).click(function(){
            buttons(1,p2,v2,vx2);
        });
    p3 = paper.rect(750, 51.25, 30, 30).attr({"fill":buttonsFillColor[0]}).click(function(){
            buttons(2,p3,v3,vx3);
        });
    p4 = paper.rect(800, 51.25, 30, 30).attr({"fill":buttonsFillColor[0]}).click(function(){
            buttons(3,p4,v4,vx4);
        });

    lblSimula = paper.text(895, 42, "Simula").attr({"font-size":16});
    pSimula = paper.rect(850, 51.25, 90, 30).attr({"fill":buttonsFillColor[0]}).click(function(){
            if(input[0]==1 && (input[1]==1 || input[2]==1)){
                alert("Il circuito non è stato aggiornato perché la configurazione immessa non è valida in BCD");
            }
            else {
                update();
            }
        });

    cletters = paper.circle(780, 150, 8).attr({"fill":buttonsFillColor[0]}).click(function(){
            if(showLetters == false){
                this.attr({"fill":"darkblue"});
                lbla.show();
                lblb.show();
                lblc.show();
                lbld.show();
                lble.show();
                lblf.show();
                lblg.show();
                showLetters = true;
            }
            else {
                this.attr({"fill":"white"});
                lbla.hide();
                lblb.hide();
                lblc.hide();
                lbld.hide();
                lble.hide();
                lblf.hide();
                lblg.hide();
                showLetters = false;
            }
        });

    v1 = paper.text(665, 90, "0").attr({"font-size":16});
    v2 = paper.text(715, 90, "0").attr({"font-size":16});
    v3 = paper.text(765, 90, "0").attr({"font-size":16});
    v4 = paper.text(815, 90, "0").attr({"font-size":16});
    vx1 = paper.text(20, 45, "0").attr({"font-size":16});
    vx2 = paper.text(20, 85, "0").attr({"font-size":16});
    vx3 = paper.text(20, 125, "0").attr({"font-size":16});
    vx4 = paper.text(20, 165, "0").attr({"font-size":16});

    lblOutput = paper.text(600, 130, "Output").attr({"font-size":16});

    displayContainer = paper.rect(650,120,100,160).attr({"fill":displayBackColor});

    sa = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("r-90 t20,30").attr({"fill":"lightgrey","stroke":displayStrokeColor});
    sb = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("t60,10").attr({"fill":"lightgrey","stroke":displayStrokeColor});
    sc = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("t60,70").attr({"fill":"lightgrey","stroke":displayStrokeColor});
    sd = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("r-90 t-100,30").attr({"fill":"lightgrey","stroke":displayStrokeColor});
    se = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("t0,70").attr({"fill":"lightgrey","stroke":displayStrokeColor});
    sf = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("t0,10").attr({"fill":"lightgrey","stroke":displayStrokeColor});
    sg = paper.path("M660,140 L670,130 L680,140 V180 L670,190 L660,180 V140Z").transform("r-90 t-40,30").attr({"fill":"lightgrey","stroke":displayStrokeColor});

    lbla = paper.text(700, 140, "a").attr({"font-size":14}).hide();
    lblb = paper.text(730, 170, "b").attr({"font-size":14}).hide();
    lblc = paper.text(730, 230, "c").attr({"font-size":14}).hide();
    lbld = paper.text(700, 260, "d").attr({"font-size":14}).hide();
    lble = paper.text(670, 230, "e").attr({"font-size":14}).hide();
    lblf = paper.text(670, 170, "f").attr({"font-size":14}).hide();
    lblg = paper.text(700, 200, "g").attr({"font-size":14}).hide();

    lblLetters = paper.text(875, 150, "Mostra lettere segmenti").attr({"font-size":16});

    update();
}